'use strict';

exports.__esModule = true;

exports.default = function (fn) {
    connectionResetDomain.run(fn);
};

var _domain = require('domain');

var _domain2 = _interopRequireDefault(_domain);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var connectionResetDomain = _domain2.default.create();

connectionResetDomain.on('error', function (err) {
    // NOTE: The nodejs throw the EPIPE error instead of the ECONNRESET error
    // when the connection is broken in some cases on MacOS
    if (err.code === 'ECONNRESET' || _os2.default.type() === 'Darwin' && err.code === 'EPIPE') return;

    connectionResetDomain.removeAllListeners('error');
    throw err;
});

module.exports = exports['default'];